## wmbusmeters 1.13.1

=== Makefile ===
# Copyright (C) 2017-2022 Fredrik Öhrström (gpl-3.0-or-later)
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# To compile for Raspberry PI ARM:
# make HOST=arm
#
# To build with debug information:
# make DEBUG=true
# make DEBUG=true HOST=arm

DESTDIR?=/

ifeq "$(HOST)" "arm"
    CXX?=arm-linux-gnueabihf-g++
    STRIP?=arm-linux-gnueabihf-strip
    BUILD=build_arm
    DEBARCH=armhf
else
    CXX?=g++
    STRIP?=strip
#--strip-unneeded --remove-section=.comment --remove-section=.note
    BUILD=build
    DEBARCH=amd64
endif

ifeq "$(DEBUG)" "true"
    DEBUG_FLAGS=-O0 -ggdb -fsanitize=address -fno-omit-frame-pointer -fprofile-arcs -ftest-coverage
    STRIP_BINARY=
    STRIP_ADMIN=
    BUILD:=$(BUILD)_debug
    ifneq '' '$(findstring clang++,$(CXX))'
        DEBUG_LDFLAGS=-fsanitize=address --coverage
        GCOV?=llvm-cov gcov
    else
        DEBUG_LDFLAGS=-lasan -lgcov --coverage
        GCOV?=gcov
    endif
else
    ifeq "$(PROFILE)" "true"
        DEBUG_FLAGS=-O0 -ggdb -fno-omit-frame-pointer -fprofile-arcs -pg
        STRIP_BINARY=
        STRIP_ADMIN=
        BUILD:=$(BUILD)_profile
        ifneq '' '$(findstring clang++,$(CXX))'
            DEBUG_LDFLAGS=
            GCOV=To_run_gcov_add_DEBUG=true
        else
            DEBUG_LDFLAGS=-lgcov --coverage
            GCOV=To_run_gcov_add_DEBUG=true
        endif
    else
        # Release build
        DEBUG_FLAGS=-Os -g
        STRIP_BINARY=cp $(BUILD)/wmbusmeters $(BUILD)/wmbusmeters.g; $(STRIP) $(BUILD)/wmbusmeters
        GCOV=To_run_gcov_add_DEBUG=true
    endif
endif

$(shell mkdir -p $(BUILD))

define DQUOTE
"
endef

#' make editor quote matching happy.

SUPRE=
SUPOST=
ifneq ($(SUDO_USER),)
# Git has a security check to prevent the wrong user from running inside the git repository.
# When we run "sudo make install" this will create problems since git is running as root instead.
# Use SUPRE/SUPOST to use su to switch back to the user for the git commands.
SUPRE=su -c $(DQUOTE)
SUPOST=$(DQUOTE) $(SUDO_USER)
endif

COMMIT_HASH?=$(shell $(SUPRE) git log --pretty=format:'%H' -n 1 $(SUPOST))
TAG?=$(shell $(SUPRE) git describe --tags $(SUPOST))
BRANCH?=$(shell $(SUPRE) git rev-parse --abbrev-ref HEAD $(SUPOST))
CHANGES?=$(shell $(SUPRE) git status -s | grep -v '?? ' $(SUPOST))

ifeq ($(BRANCH),master)
  BRANCH:=
else
  BRANCH:=$(BRANCH)_
endif

VERSION:=$(BRANCH)$(TAG)
LOCALDEBVERSION:=$(BRANCH)$(TAG)
LOCALCHANGES:=

ifneq ($(strip $(CHANGES)),)
  # There are local un-committed changes.
  VERSION:=$(VERSION) with local changes
  COMMIT_HASH:=$(COMMIT_HASH)+
  LOCALCHANGES:=true
endif

$(shell echo "#define VERSION \"$(VERSION)\"" > $(BUILD)/version.h.tmp)
$(shell echo "#define COMMIT \"$(COMMIT_HASH)\"" >> $(BUILD)/version.h.tmp)

PREV_VERSION:=$(shell cat -n $(BUILD)/version.h 2> /dev/null)
CURR_VERSION:=$(shell cat -n $(BUILD)/version.h.tmp 2>/dev/null)

ifneq ($(PREV_VERSION),$(CURR_VERSION))
$(shell mv $(BUILD)/version.h.tmp $(BUILD)/version.h)
$(info New version number generates new $(BUILD)/version.h)
else
$(shell rm $(BUILD)/version.h.tmp)
endif

$(info Building $(VERSION))

FUZZFLAGS ?= -DFUZZING=false
CXXFLAGS ?= $(DEBUG_FLAGS) $(FUZZFLAGS) -fPIC -std=c++11 -Wall -Werror=format-security -Wno-unused-function
# Additional fedora rpm package build flags
# -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection
CXXFLAGS += -I$(BUILD)
LDFLAGS  ?= $(DEBUG_LDFLAGS)

USBLIB = -lusb-1.0

ifeq ($(shell uname -s),FreeBSD)
    CXXFLAGS += -I/usr/local/include
    LDFLAGS  += -L/usr/local/lib
    USBLIB    =  -lusb
endif

$(BUILD)/%.o: src/%.cc $(wildcard src/%.h)
	$(CXX) $(CXXFLAGS) $< -c -E > $@.src
	$(CXX) $(CXXFLAGS) $< -MMD -c -o $@

PROG_OBJS:=\
	$(BUILD)/aes.o \
	$(BUILD)/aescmac.o \
	$(BUILD)/bus.o \
	$(BUILD)/cmdline.o \
	$(BUILD)/config.o \
	$(BUILD)/dvparser.o \
	$(BUILD)/formula.o \
	$(BUILD)/mbus_rawtty.o \
	$(BUILD)/metermanager.o \
	$(BUILD)/meters.o \
	$(BUILD)/manufacturer_specificities.o \
	$(BUILD)/printer.o \
	$(BUILD)/rtlsdr.o \
	$(BUILD)/serial.o \
	$(BUILD)/shell.o \
	$(BUILD)/sha256.o \
	$(BUILD)/threads.o \
	$(BUILD)/translatebits.o \
	$(BUILD)/util.o \
	$(BUILD)/units.o \
	$(BUILD)/wmbus.o \
	$(BUILD)/wmbus_amb8465.o \
	$(BUILD)/wmbus_im871a.o \
	$(BUILD)/wmbus_cul.o \
	$(BUILD)/wmbus_rtlwmbus.o \
	$(BUILD)/wmbus_rtl433.o \
	$(BUILD)/wmbus_simulator.o \
	$(BUILD)/wmbus_rawtty.o \
	$(BUILD)/wmbus_rc1180.o \
	$(BUILD)/wmbus_utils.o \
	$(BUILD)/lora_iu880b.o \

# If you run: "make DRIVER=minomess" then only driver_minomess.cc will be compiled into wmbusmeters.
# The old style drivers meter_xyz.cc must always be compiled in, but eventually they will be gone.

ifeq ($(DRIVER),)
	DRIVER_OBJS:=$(wildcard src/meter_*.cc) $(wildcard src/driver_*.cc)
else
    $(info Building a single driver $(DRIVER))
	DRIVER_OBJS:=src/driver_auto.cc src/driver_unknown.cc $(wildcard src/meter_*.cc) src/driver_$(DRIVER).cc
endif
DRIVER_OBJS:=$(patsubst src/%.cc,$(BUILD)/%.o,$(DRIVER_OBJS))

all: $(BUILD)/wmbusmeters $(BUILD)/wmbusmetersd $(BUILD)/wmbusmeters.g $(BUILD)/testinternals

deb_release:
	@if [ "$(RELEASE)" = "" ] ; then echo "Usage: make deb RELEASE=1.2.3" ; exit 1 ; fi
	@if [ "$$(cat deb/changelog  | grep wmbusmeters\ \( | grep -o $(RELEASE))" != "$(RELEASE)" ]; then \
        echo "Changelog not updated with this release! It says:" ; \
	    head -n 1 deb/changelog ; \
        exit 1 ; \
    fi
	@rm -rf packaging
	@mkdir -p packaging
	@echo "Checking out tag $(RELEASE)..."
	@(cd packaging ; git clone $(PWD) wmbusmeters-$(RELEASE) ; cd wmbusmeters-$(RELEASE) ; git -c advice.detachedHead=false checkout tags/$(RELEASE) )
	@(cd packaging/wmbusmeters-$(RELEASE) ; git show -s --format=%ct > ../release_date )
	@echo "Removing git history..."
	@(cd packaging ; rm -rf wmbusmeters-$(RELEASE)/.git )
	@echo "Setting file timestamps to commit date..."
	@(cd packaging ; export UT=$$(cat ./release_date) ; find . -exec touch -d "@$$UT" \{\} \; )
	@echo "Creating orig archive..."
	@(cd packaging ; tar czf ./wmbusmeters_$(RELEASE).orig.tar.gz wmbusmeters-$(RELEASE) )
	@echo "Running debbuild..."
	@(cd packaging/wmbusmeters-$(RELEASE) ; cp -a deb debian; debuild )

deb_local:
	@rm -rf packaging
	@mkdir -p packaging
	@echo "Using latest commit..."
	@(cd packaging ; git clone $(PWD) wmbusmeters-$(LOCALDEBVERSION) ; cd wmbusmeters-$(LOCALDEBVERSION) )
	@echo "Applying local changes..."
	@(git diff > packaging/local_patch_$(LOCALDEBVERSION) ; \
	  cd packaging/wmbusmeters-$(LOCALDEBVERSION) ; \
	  patch -p 1 < ../local_patch_$(LOCALDEBVERSION) )
	@(cd packaging/wmbusmeters-$(LOCALDEBVERSION) ; git show -s --format=%ct > ../release_date )
	@echo "Removing git history..."
	@(cd packaging ; rm -rf wmbusmeters-$(LOCALDEBVERSION)/.git )
	@echo "Setting file timestamps to commit date..."
	@(cd packaging ; export UT=$$(cat ./release_date) ; find . -exec touch -d "@$$UT" \{\} \; )
	@echo "Creating orig archive..."
	@(cd packaging ; tar czf ./wmbusmeters_$(LOCALDEBVERSION).orig.tar.gz wmbusmeters-$(LOCALDEBVERSION) )
	@echo "Installing debian directory..."
	@(cd packaging/wmbusmeters-$(LOCALDEBVERSION) ; cp -a deb debian )
	@echo "Creating local dummy changelog..."
	@echo "wmbusmeters ($(LOCALDEBVERSION)-99) unstable; urgency=low\n\n" \
          "  * Local build of deb current sources $(VERSION) $(COMMIT_HASH)\n\n" \
          " -- No User <nouser@nowhere> $(shell LANG=C date -R)\n" > packaging/wmbusmeters-$(LOCALDEBVERSION)/debian/changelog
	@echo "Running debbuild..."
	@(cd packaging/wmbusmeters-$(LOCALDEBVERSION) ; debuild -i -us -uc -b )

# Check docs verifies that all options in the source have been mentioned in the README and in the man page.
# Also any option not in the source but mentioned in the docs is warned for as well.
check_docs:
	@rm -f /tmp/options_in_*
	@cat src/cmdline.cc  | grep -o -- '--[a-z][a-z]*' | sort | uniq | grep -v internaltesting > /tmp/options_in_code
	@cat wmbusmeters.1   | grep -o -- '--[a-z][a-z]*' | sort | uniq | grep -v internaltesting > /tmp/options_in_man
	@cat README.md | grep -o -- '--[a-z][a-z]*' | sort | uniq | grep -v internaltesting > /tmp/options_in_readme
	@$(BUILD)/wmbusmeters --help | grep -o -- '--[a-z][a-z]*' | sort | uniq | grep -v internaltesting > /tmp/options_in_binary
	@diff /tmp/options_in_code /tmp/options_in_man || echo CODE_VS_MAN
	@diff /tmp/options_in_code /tmp/options_in_readme || echo CODE_VS_README
	@diff /tmp/options_in_code /tmp/options_in_binary || echo CODE_VS_BINARY
	@echo "OK docs"

install:
	@if [ ! -f $(BUILD)/wmbusmeters ] ; then echo "Cannot find the binary to install! You have to run just \"make\" first!" ; exit 1 ; fi
	@echo "Installing $(BUILD)/wmbusmeters"
	@./install.sh $(BUILD)/wmbusmeters $(DESTDIR) $(EXTRA_INSTALL_OPTIONS)

# Uninstall binaries and manpages. But keep configuration data and wmbusmeters user/group.
uninstall:
	@./uninstall.sh /

# Uninstall everything including configuration and wmbusmeters user/group.
uninstall_purge:
	@./uninstall.sh / --purge

snapcraft:
	snapcraft

$(BUILD)/main.o: $(BUILD)/short_manual.h $(BUILD)/version.h $(BUILD)/authors.h

$(BUILD)/authors.h:
	./scripts/generate_authors.sh $(BUILD)/authors.h

# Build binary with debug information. ~15M size binary.
$(BUILD)/wmbusmeters.g: $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/main.o $(BUILD)/short_manual.h
	$(CXX) -o $(BUILD)/wmbusmeters.g $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/main.o $(LDFLAGS) -lrtlsdr $(USBLIB) -lpthread

# Production build will have debug information stripped. ~1.5M size binary.
# DEBUG=true builds, which has address sanitizer code, will always keep the debug information.
$(BUILD)/wmbusmeters: $(BUILD)/wmbusmeters.g
	cp $(BUILD)/wmbusmeters.g $(BUILD)/wmbusmeters
	$(STRIP_BINARY)

$(BUILD)/wmbusmetersd: $(BUILD)/wmbusmeters
	cp $(BUILD)/wmbusmeters $(BUILD)/wmbusmetersd

$(BUILD)/short_manual.h: README.md
	echo 'R"MANUAL(' > $(BUILD)/short_manual.h
	sed -n '/wmbusmeters version/,/```/p' README.md \
	| grep -v 'wmbusmeters version' \
	| grep -v '```' >> $(BUILD)/short_manual.h
	echo ')MANUAL";' >> $(BUILD)/short_manual.h

testinternals: $(BUILD)/testinternals

$(BUILD)/testinternals.o: $(PROG_OBJS) $(DRIVER_OBJS) $(wildcard src/*.h)

$(BUILD)/testinternals: $(BUILD)/testinternals.o
	$(CXX) -o $(BUILD)/testinternals $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/testinternals.o $(LDFLAGS) -lrtlsdr $(USBLIB) -lpthread

$(BUILD)/fuzz: $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/fuzz.o
	$(CXX) -o $(BUILD)/fuzz $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/fuzz.o $(LDFLAGS) -lrtlsdr -lpthread

clean_executables:
	rm -rf build/wmbusmeters* build_arm/wmbusmeters* build_debug/wmbusmeters* build_arm_debug/wmbusmeters* *~
	rm -rf build/testinternal* build_arm/testinternal* build_debug/testinternal* build_arm_debug/testinternal*
	$(RM) testaes/test_input.txt testaes/test_stderr.txt
	$(RM) testoutput/test_expected.txt testoutput/test_input.txt \
          testoutput/test_response.txt testoutput/test_responses.txt \
          testoutput/test_stderr.txt

clean:
	rm -rf build/* build_arm/* build_debug/* build_arm_debug/* build_profile/* *~
	$(RM) testaes/test_input.txt testaes/test_stderr.txt
	$(RM) testoutput/test_expected.txt testoutput/test_input.txt \
          testoutput/test_response.txt testoutput/test_responses.txt \

=== debian/changelog ===
wmbusmeters (1.13.1-3) experimental; urgency=medium

  * Update build dependencies.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Sat, 20 May 2023 12:14:35 +0200

wmbusmeters (1.13.1-2) experimental; urgency=medium

  * Update Vcs-Git and Vcs-Browser.
  * Add build missing dependencies.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Mon, 15 May 2023 16:17:15 +0200

wmbusmeters (1.13.1-1) experimental; urgency=medium

  * First package upload (Closes: #998721).
  * Upload sponsored by Petter Reinholdtsen.

 -- Fredrik Öhrström <oehrstroem@gmail.com>  Mon, 08 May 2023 13:14:15 +0200

=== debian/control ===
Source: wmbusmeters
Section: comm
Priority: optional
Maintainer: Fredrik Öhrström <oehrstroem@gmail.com>
Build-Depends: debhelper-compat (= 13)
 , librtlsdr-dev
 , jq
 , xxd
 , netcat-openbsd
Standards-Version: 4.6.1.0
Homepage: https://github.com/wmbusmeters/wmbusmeters
Vcs-Browser: https://salsa.debian.org/weetmuts/package-wmbusmeters.git
Vcs-Git: https://salsa.debian.org/weetmuts/package-wmbusmeters.git
Rules-Requires-Root: no

Package: wmbusmeters
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
 , adduser
Suggests: rtl-wmbus
Description: read wireless and wired M-Bus (EN13757 OMS) telegrams from utility meters
 Receives and decodes C1, T1 or S1 telegrams (using
 the wireless or wired mbus protocol) to acquire utility meter
 readings. The readings can then be published using MQTT,
 curled to a REST API, inserted into a database or stored in a log file.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

LPAR=(
RPAR=)
CHANGELOG_RELEASE=$(shell cat debian/changelog | head -n 1 | grep -o '$(LPAR).*$(RPAR)' | tr -d '$(LPAR)$(RPAR)' )

override_dh_auto_build:
	$(MAKE) COMMIT_HASH= TAG=$(CHANGELOG_RELEASE) BRANCH= CHANGES=

override_dh_builddeb:
	dh_builddeb -- -Zgzip

## wmbusmeters 1.20.0

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (C) 2017-2022 Fredrik Öhrström (gpl-3.0-or-later)
+# Copyright (C) 2017-2024 Fredrik Öhrström (gpl-3.0-or-later)
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,6 +21,12 @@
 # make DEBUG=true HOST=arm
 
 DESTDIR?=/
+
+ifeq "$(DEBUG)" "true"
+  include $(wildcard build_debug/*/spec.gmk)
+else
+  include $(wildcard build/*/spec.gmk)
+endif
 
 ifeq "$(HOST)" "arm"
     CXX?=arm-linux-gnueabihf-g++
@@ -124,7 +130,7 @@
 $(info Building $(VERSION))
 
 FUZZFLAGS ?= -DFUZZING=false
-CXXFLAGS ?= $(DEBUG_FLAGS) $(FUZZFLAGS) -fPIC -std=c++11 -Wall -Werror=format-security -Wno-unused-function
+CXXFLAGS ?= $(EXTRA_CXXFLAGS) $(DEBUG_FLAGS) $(FUZZFLAGS) -fPIC -std=c++11 -Wall -Werror=format-security -Wno-unused-function
 # Additional fedora rpm package build flags
 # -O2 -flto=auto -ffat-lto-objects -fexceptions -g -grecord-gcc-switches -pipe -Wall -Werror=format-security -Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong -mtune=generic -fasynchronous-unwind-tables -fstack-clash-protection -fcf-protection
 CXXFLAGS += -I$(BUILD)
@@ -138,16 +144,27 @@
     USBLIB    =  -lusb
 endif
 
+ifeq ($(shell uname -s),Darwin)
+    CXXFLAGS += -I$(shell brew --prefix)/include
+    LDFLAGS  += -L$(shell brew --prefix)/lib
+endif
+
 $(BUILD)/%.o: src/%.cc $(wildcard src/%.h)
 	$(CXX) $(CXXFLAGS) $< -c -E > $@.src
 	$(CXX) $(CXXFLAGS) $< -MMD -c -o $@
 
+$(BUILD)/%.o: src/%.c $(wildcard src/%.h)
+	$(CXX) -I/usr/include/libxml2 $(CXXFLAGS) $< -c -E > $@.src
+	$(CXX) -I/usr/include/libxml2 -fpermissive $(CXXFLAGS)  $< -MMD -c -o $@
+
 PROG_OBJS:=\
+	$(BUILD)/address.o \
 	$(BUILD)/aes.o \
 	$(BUILD)/aescmac.o \
 	$(BUILD)/bus.o \
 	$(BUILD)/cmdline.o \
 	$(BUILD)/config.o \
+	$(BUILD)/drivers.o \
 	$(BUILD)/dvparser.o \
 	$(BUILD)/formula.o \
 	$(BUILD)/mbus_rawtty.o \
@@ -166,13 +183,16 @@
 	$(BUILD)/wmbus.o \
 	$(BUILD)/wmbus_amb8465.o \
 	$(BUILD)/wmbus_im871a.o \
+	$(BUILD)/wmbus_iu891a.o \
 	$(BUILD)/wmbus_cul.o \
 	$(BUILD)/wmbus_rtlwmbus.o \
 	$(BUILD)/wmbus_rtl433.o \
 	$(BUILD)/wmbus_simulator.o \
 	$(BUILD)/wmbus_rawtty.o \
+	$(BUILD)/wmbus_xmqtty.o \
 	$(BUILD)/wmbus_rc1180.o \
 	$(BUILD)/wmbus_utils.o \
+	$(BUILD)/xmq.o \
 	$(BUILD)/lora_iu880b.o \
 
 # If you run: "make DRIVER=minomess" then only driver_minomess.cc will be compiled into wmbusmeters.
@@ -182,33 +202,13 @@
 	DRIVER_OBJS:=$(wildcard src/meter_*.cc) $(wildcard src/driver_*.cc)
 else
     $(info Building a single driver $(DRIVER))
-	DRIVER_OBJS:=src/driver_auto.cc src/driver_unknown.cc $(wildcard src/meter_*.cc) src/driver_$(DRIVER).cc
+	DRIVER_OBJS:=src/driver_auto.cc src/driver_unknown.cc src/driver_dynamic.cc $(wildcard src/meter_*.cc) src/driver_$(DRIVER).cc
 endif
 DRIVER_OBJS:=$(patsubst src/%.cc,$(BUILD)/%.o,$(DRIVER_OBJS))
 
 all: $(BUILD)/wmbusmeters $(BUILD)/wmbusmetersd $(BUILD)/wmbusmeters.g $(BUILD)/testinternals
 
-deb_release:
-	@if [ "$(RELEASE)" = "" ] ; then echo "Usage: make deb RELEASE=1.2.3" ; exit 1 ; fi
-	@if [ "$$(cat deb/changelog  | grep wmbusmeters\ \( | grep -o $(RELEASE))" != "$(RELEASE)" ]; then \
-        echo "Changelog not updated with this release! It says:" ; \
-	    head -n 1 deb/changelog ; \
-        exit 1 ; \
-    fi
-	@rm -rf packaging
-	@mkdir -p packaging
-	@echo "Checking out tag $(RELEASE)..."
-	@(cd packaging ; git clone $(PWD) wmbusmeters-$(RELEASE) ; cd wmbusmeters-$(RELEASE) ; git -c advice.detachedHead=false checkout tags/$(RELEASE) )
-	@(cd packaging/wmbusmeters-$(RELEASE) ; git show -s --format=%ct > ../release_date )
-	@echo "Removing git history..."
-	@(cd packaging ; rm -rf wmbusmeters-$(RELEASE)/.git )
-	@echo "Setting file timestamps to commit date..."
-	@(cd packaging ; export UT=$$(cat ./release_date) ; find . -exec touch -d "@$$UT" \{\} \; )
-	@echo "Creating orig archive..."
-	@(cd packaging ; tar czf ./wmbusmeters_$(RELEASE).orig.tar.gz wmbusmeters-$(RELEASE) )
-	@echo "Running debbuild..."
-	@(cd packaging/wmbusmeters-$(RELEASE) ; cp -a deb debian; debuild )
-
+# Create a local binary only package.
 deb_local:
 	@rm -rf packaging
 	@mkdir -p packaging
@@ -270,7 +270,7 @@
 
 # Build binary with debug information. ~15M size binary.
 $(BUILD)/wmbusmeters.g: $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/main.o $(BUILD)/short_manual.h
-	$(CXX) -o $(BUILD)/wmbusmeters.g $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/main.o $(LDFLAGS) -lrtlsdr $(USBLIB) -lpthread
+	$(CXX) -o $(BUILD)/wmbusmeters.g $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/main.o $(LDFLAGS) -lrtlsdr -lxml2 $(USBLIB) -lpthread
 
 # Production build will have debug information stripped. ~1.5M size binary.
 # DEBUG=true builds, which has address sanitizer code, will always keep the debug information.
@@ -293,10 +293,10 @@
 $(BUILD)/testinternals.o: $(PROG_OBJS) $(DRIVER_OBJS) $(wildcard src/*.h)
 
 $(BUILD)/testinternals: $(BUILD)/testinternals.o
-	$(CXX) -o $(BUILD)/testinternals $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/testinternals.o $(LDFLAGS) -lrtlsdr $(USBLIB) -lpthread
+	$(CXX) -o $(BUILD)/testinternals $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/testinternals.o $(LDFLAGS) -lrtlsdr -lxml2 $(USBLIB) -lpthread
 
 $(BUILD)/fuzz: $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/fuzz.o
-	$(CXX) -o $(BUILD)/fuzz $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/fuzz.o $(LDFLAGS) -lrtlsdr -lpthread
+	$(CXX) -o $(BUILD)/fuzz $(PROG_OBJS) $(DRIVER_OBJS) $(BUILD)/fuzz.o $(LDFLAGS) -lrtlsdr -lxml2 -lpthread
 
 clean_executables:
 	rm -rf build/wmbusmeters* build_arm/wmbusmeters* build_debug/wmbusmeters* build_arm_debug/wmbusmeters* *~
@@ -311,3 +311,19 @@
 	$(RM) testaes/test_input.txt testaes/test_stderr.txt
 	$(RM) testoutput/test_expected.txt testoutput/test_input.txt \
           testoutput/test_response.txt testoutput/test_responses.txt \
+          testoutput/test_stderr.txt
+
+distclean: clean
+	$(RM) config.log
+
+clean_cc:
+	find . -name "*.gcov" -delete
+	find . -name "*.gcda" -delete
+
+# This generates annotated source files ending in .gcov
+# inside the build_debug where non-executed source lines are marked #####
+gcov:
+	@if [ "$(DEBUG)" = "" ]; then echo "You have to run \"make gcov DEBUG=true\""; exit 1; fi
+	$(GCOV) -o build_debug $(PROG_OBJS) $(DRIVER_OBJS)
+	mv *.gcov build_debug
+

=== drivers/Makefile ===

$(shell mkdir -p build/test)

PROG?=../build/wmbusmeters

database:
	@./generate.sh $(PROG)

web:
	@mkdir -p ../build/web
	@./generate_index.sh

tests:
	@echo -n "// Generated " > build/generated_tests.xmq
	@date +%Y-%m-%d_%H:%M >> build/generated_tests.xmq
	@for i in $(wildcard src/*) ; do xmq $$i select /driver/tests/test to-xmq >> build/generated_tests.xmq; done

install: database tests
	@grep -v "// Generated " < build/generated_database.cc > build/a
	@grep -v "// Generated " < ../src/generated_database.cc > build/b
	@if ! diff build/a build/b ; then \
            cp build/generated_database.cc ../src ; echo "Installed db"; else echo "No changes db." ; fi
	@grep -v "// Generated " < build/generated_tests.xmq > build/a
	@grep -v "// Generated " < ../tests/generated_tests.xmq > build/b
	@if ! diff build/a build/b ; then \
            cp build/generated_tests.xmq ../tests/generated_tests.xmq ; echo "Installed tests." ; else echo "No changes test." ; fi

generate_ha_discovery:
	@mkdir -p build/ha_mqtt_discovery
	@for i in $(wildcard src/*) ; do echo $$i ; xmq $$i transform to-ha-discovery.xslq to-json | jq . > build/ha_mqtt_discovery/$$(basename $${i%%.xmq}.json); done

pretty:
	@for i in $(wildcard src/*.xmq) ; do xmq $$i > tmp ; mv tmp $$i ; done

test:
	@for i in $(wildcard src/*) ; do ./test.sh $(PROG) $$i ; done

.PHONY: database web tests install test

=== debian/changelog ===
wmbusmeters (1.20.0-1) unstable; urgency=medium

  * [c2dbdb8] New upstream version 1.20.0.
  * [f770fe4] Add libxslt1-dev build dependency.
  * [3b69199] Update copyright file and licenses.
  * [02f0ef9] Remove explicit gzip compression override.
  * [052a143] Fix paths in systemd. (Closes: #1109566)
  * [98b3af9] Add support for DME Type 173 variant.
  * [7e39685] Add basic salsa-ci configuration.
  * [89d3279] Update maintainer and add uploaders.
  * [9fec38b] Update Standards-Version and reformat control. (Closes: #1036784)
  * [68598d4] Respect CPPFLAGS during build.
  * [afdd948] Add comprehensive autopkgtests.

 -- Anton Gladky <gladk@debian.org>  Thu, 05 Feb 2026 19:57:20 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CPPFLAGS_MAINT_APPEND = -D_FORTIFY_SOURCE=2

CHANGELOG_VERSION := $(shell dpkg-parsechangelog -S Version)

%:
	dh $@

override_dh_auto_build:
	$(MAKE) COMMIT_HASH= TAG=$(CHANGELOG_VERSION) BRANCH= CHANGES=

override_dh_auto_test:
	$(MAKE) test COMMIT_HASH= TAG=$(CHANGELOG_VERSION) BRANCH= CHANGES=

=== debian/tests/control ===
Tests: basic-functionality
Depends: @, jq

Tests: version-check
Depends: @

Tests: help-output
Depends: @

Tests: robustness
Depends: @
